Index: FlagInfo.cxx
===================================================================
--- FlagInfo.cxx	(revision 20911)
+++ FlagInfo.cxx	(working copy)
@@ -57,248 +79,1575 @@
   flag.flightTime	  = 0.0f;
   flag.flightEnd	  = 0.0f;
   flag.initialVelocity    = 0.0f;
-  player		  = -1;
-  grabs			  = 0;
-  required		  = false;
 }
 
-void FlagInfo::setSize(int _numFlags)
-{
-  // sanity check
-  if (_numFlags > 1000000) {
-    std::cerr << "WARNING: FlagInfo::setSize was given an insane flag count of " << _numFlags << std::endl;
-    std::cerr << "clamping to 1000000 flags just for kicks" << std::endl;
-    _numFlags = 100000;
-  }
 
-  numFlags = _numFlags;
-  delete[] flagList;
-  flagList = NULL;
-  if (numFlags)
-    flagList = new FlagInfo[numFlags];
-  for (int i = 0; i < numFlags; i++)
-    flagList[i].flagIndex = i;
-}
-
-void FlagInfo::setAllowed(std::vector<FlagType*> allowed)
+void FlagInfo::setExtraFlag()
 {
-  allowedFlags = allowed;
+  extra = true;
+  random = false;
+  flag.type = Flags::Null;
 }
 
-void FlagInfo::setExtra(int extra)
-{
-  numExtraFlags = extra;
-}
 
-int FlagInfo::lookupFirstTeamFlag(int teamindex)
+void FlagInfo::setRandomFlag()
 {
-  for (int i = 0; i < numFlags; i++) {
-    if (flagList[i].flag.type->flagTeam == teamindex)
-      return i;
-  }
-  return -1;
+  extra = false;
+  random = true;
+  flag.type = Flags::Null;
 }
 
-void FlagInfo::setRequiredFlag(FlagType *desc)
+
+void FlagInfo::setForcedFlag(const FlagType *desc)
 {
-  required = true;
-  flag.type = desc;
+  extra = false;
+  random = false;
+  flag.type = (FlagType*) desc; // FIXME - cast cheat
 }
 
+
 void FlagInfo::addFlag()
 {
+  if (flag.type == Flags::Null) {
+    // pick a random flag
+    flag.type = (FlagType*) FLAGMGR.pickRandomFlagType(); // FIXME - cast cheat
+    if (flag.type == Flags::Null) {
+      return; // no random flags available, bail
+    }
+  }
+
   const float flagAltitude = BZDB.eval(StateDatabase::BZDB_FLAGALTITUDE);
   const float gravity      = BZDBCache::gravity;
   const float maxGrabs     = BZDB.eval(StateDatabase::BZDB_MAXFLAGGRABS);
 
   // flag in now entering game
   numFlagsInAir++;
-  flag.status	  = FlagComing;
+  flag.status = FlagComing;
 
   // compute drop time
   const float flightTime = 2.0f * sqrtf(-2.0f * flagAltitude / gravity);
-  flag.flightTime	= 0.0f;
-  flag.flightEnd	 = flightTime;
+  flag.flightTime        = 0.0f;
+  flag.flightEnd         = flightTime;
   flag.initialVelocity   = -0.5f * gravity * flightTime;
-  dropDone	       = TimeKeeper::getCurrent();
-  dropDone	      += flightTime;
+  dropDone               = TimeKeeper::getCurrent();
+  dropDone              += flightTime;
 
-  if (flag.type == Flags::Null)
-    // pick a random flag
-    flag.type = allowedFlags[(int)(allowedFlags.size() * (float)bzfrand())];
 
   // decide how sticky the flag will be
-  if (flag.type->flagQuality == FlagBad)
+  if (flag.type->flagQuality == FlagBad) {
     flag.endurance = FlagSticky;
-  else
+  } else {
     flag.endurance = FlagUnstable;
+  }
 
   // how times will it stick around
-  if ((flag.endurance == FlagSticky) || (flag.type == Flags::Thief))
-    grabs = 1;
-  else
-    grabs = int(floor(maxGrabs * (float)bzfrand())) + 1;
+  if ((flag.endurance == FlagSticky) || (flag.type == Flags::Thief)) {
+    grabsLeft = 1;
+  } else {
+    grabsLeft = int(floor(maxGrabs * (float)bzfrand())) + 1;
+  }
 }
 
-void *FlagInfo::pack(void *buf, bool hide)
+
+void* FlagInfo::pack(void *buf, bool hide)
 {
-  if (FlagInfo::flagList[flagIndex].flag.type->flagTeam != ::NoTeam)
+  if ((player != -1) || (flag.type->flagTeam != ::NoTeam)) {
     hide = false;
-  if (FlagInfo::flagList[flagIndex].player != -1)
-    hide = false;
+  }
+
   buf = nboPackUShort(buf, flagIndex);
-  if (hide)
-    buf = FlagInfo::flagList[flagIndex].flag.fakePack(buf);
-  else
-    buf = FlagInfo::flagList[flagIndex].flag.pack(buf);
+  if (hide) {
+    buf = flag.fakePack(buf);
+  } else {
+    buf = flag.pack(buf);
+  }
+
   return buf;
 }
 
+
 void FlagInfo::dropFlag(float pos[3], float landingPos[3], bool vanish)
 {
   numFlagsInAir++;
-  flag.status	     = vanish ? FlagGoing : FlagInAir;
+  flag.status = vanish ? FlagGoing : FlagInAir;
 
   flag.landingPosition[0] = landingPos[0];
   flag.landingPosition[1] = landingPos[1];
   flag.landingPosition[2] = landingPos[2];
 
-  flag.position[0]       = landingPos[0];
-  flag.position[1]       = landingPos[1];
-  flag.position[2]       = landingPos[2];
+  flag.position[0] = landingPos[0];
+  flag.position[1] = landingPos[1];
+  flag.position[2] = landingPos[2];
   flag.launchPosition[0] = pos[0];
   flag.launchPosition[1] = pos[1];
   flag.launchPosition[2] = pos[2] + BZDBCache::tankHeight;
 
   // compute flight info -- flight time depends depends on start and end
   // altitudes and desired height above start altitude
-  const float gravity	= BZDBCache::gravity;
+  const float gravity        = BZDBCache::gravity;
   const float flagAltitude   = BZDB.eval(StateDatabase::BZDB_FLAGALTITUDE);
   const float thrownAltitude = (flag.type == Flags::Shield) ?
     BZDB.eval(StateDatabase::BZDB_SHIELDFLIGHT) * flagAltitude : flagAltitude;
   const float maxAltitude    = pos[2] + thrownAltitude;
-  const float upTime	 = sqrtf(-2.0f * thrownAltitude / gravity);
+  const float upTime         = sqrtf(-2.0f * thrownAltitude / gravity);
   const float downTime       = sqrtf(-2.0f * (maxAltitude - pos[2]) / gravity);
   const float flightTime     = upTime + downTime;
 
-  dropDone	     = TimeKeeper::getCurrent();
-  dropDone	    += flightTime;
+  dropDone = TimeKeeper::getCurrent();
+  dropDone += flightTime;
   flag.flightTime      = 0.0f;
   flag.flightEnd       = flightTime;
   flag.initialVelocity = -gravity * upTime;
 }
 
-void FlagInfo::resetFlag(float position[3], bool teamIsEmpty)
+
+void FlagInfo::resetFlag(const float position[3], bool teamIsEmpty)
 {
   // reset a flag's info
-  player      = -1;
+  player = -1;
+
   // if it's a random flag, reset flag id
-  if (flagIndex >= numFlags - numExtraFlags)
+  if (extra || random) {
     flag.type = Flags::Null;
+  }
 
   flag.position[0] = position[0];
   flag.position[1] = position[1];
   flag.position[2] = position[2];
 
   // required flags mustn't just disappear
-  if (required) {
-    if (flag.type->flagTeam == ::NoTeam)
+  if (extra || random) {
+    flag.status = FlagNoExist;
+  }
+  else {
+    if (flag.type->flagTeam == ::NoTeam) {
       // flag in now entering game
       addFlag();
-    else if (teamIsEmpty)
+    } else if (teamIsEmpty) {
       flag.status = FlagNoExist;
-    else
+    } else {
       flag.status = FlagOnGround;
-  } else {
-    flag.status = FlagNoExist;
+    }
   }
 }
 
+
 void FlagInfo::grab(int playerIndex)
 {
   flag.status = FlagOnTank;
   flag.owner  = playerIndex;
   player      = playerIndex;
-  numShots    = 0;
+  shotCount   = 0;
 }
 
-int FlagInfo::teamIndex() const
+
+bool FlagInfo::landing(const TimeKeeper &tm)
 {
-  return flag.type->flagTeam;
+  if (numFlagsInAir <= 0) {
+    return false;
+  }
+
+  bool land = false;
+
+  if ((dropDone - tm) <= 0.0f) {
+    if ((flag.status == FlagInAir) ||
+        (flag.status == FlagComing)) {
+      flag.status = FlagOnGround;
+      numFlagsInAir--;
+      land = true;
+    }
+    else if (flag.status == FlagGoing) {
+      flag.status = FlagNoExist;
+      numFlagsInAir--;
+      land = true;
+    }
+  }
+
+  return land;
 }
 
-int FlagInfo::getIndex() const
+
+void FlagInfo::getTextualInfo(char *message) const
 {
-  return flagIndex;
+  char status;
+  switch (flag.status) {
+    case FlagNoExist:  { status = 'N'; break; }
+    case FlagOnGround: { status = 'G'; break; }
+    case FlagOnTank:   { status = 'T'; break; }
+    case FlagInAir:    { status = 'a'; break; }
+    case FlagComing:   { status = 'c'; break; }
+    case FlagGoing:    { status = 'g'; break; }
+  }
+  
+  int flagLimit = -1;
+  FlagNumberMap::const_iterator it = clOptions->flagLimit.find(flag.type);
+  if (it != clOptions->flagLimit.end()) {
+    flagLimit = it->second;
+  }
+
+  sprintf(message, "#%-3d i:%-3s p:%-3d g:%-2d r:%c  e:%c  s:%c  z:%c  "
+		   "p:{%.1f, %.1f, %.1f}",
+	  flagIndex, flag.type->flagAbbv, player, grabsLeft,
+	  random ? 'Y' : 'N', extra ? 'Y' : 'N',
+	  status, (srcZone != NULL) ? 'Y' : 'N',
+	  flag.position[0], flag.position[1], flag.position[2]);
 }
 
-float FlagInfo::getNextDrop(TimeKeeper &tm)
+
+/******************************************************************************/
+//
+// FlagManager
+//
+
+FlagManager FlagManager::manager;
+
+
+// fake flag types
+const FlagType* FlagManager::allFlagType  = (const FlagType*)1;
+const FlagType* FlagManager::badFlagType  = (const FlagType*)2;
+const FlagType* FlagManager::goodFlagType = (const FlagType*)3;
+const FlagType* FlagManager::teamFlagType = (const FlagType*)4;
+
+
+FlagType* FlagManager::getTeamFlagType(int t)
 {
+  FlagType* teamFlags[5] = {
+    Flags::Null, // rogue
+    Flags::RedTeam,
+    Flags::GreenTeam,
+    Flags::BlueTeam,
+    Flags::PurpleTeam
+  };
+  if ((t >= RedTeam) && (t <= PurpleTeam)) {
+    return teamFlags[t];
+  }
+  return Flags::Null;
+}
+
+
+FlagManager::FlagManager()
+{
+  flagList = NULL;
+  clear();
+  forbidType(Flags::Null);
+  zoneIdentifyFlag = false;
+  minRandomDelay = 1.0f;
+  minRandomDelay = 5.0f;
+  nextRandomInsertion = TimeKeeper::getCurrent();
+  return;
+}
+
+
+FlagManager::~FlagManager()
+{
+  clear();
+  return;
+}
+
+
+void FlagManager::clear()
+{
+  forcedFlags.clear();
+  randomFlags.clear();
+  forbiddenFlags.clear();
+
+  delete[] flagList;
+  flagList= NULL;
+  fullCount = 0;
+  zoneCount = 0;
+  extraCount = 0;
+  forcedCount = 0;
+  randomCount = 0;
+
+  numFlagsInAir = 0; //FIXME?
+
+  return;
+}
+
+
+void FlagManager::clearRandomPool()
+{
+  randomFlags.clear();
+  return;
+}
+
+
+int FlagManager::getZoneTeamFlagCount(const FlagType* flagType,
+                                      const EntryZones& entryZones) const
+{
+  if (!isAllowedType(flagType)) {
+    return 0;
+  }
+  // tally zone team flags
+  int count = 0;
+  const ZoneList& zl = entryZones.getZoneList();
+  for (int z = 0; z < (int)zl.size(); z++) {
+    const CustomZone& zone = zl[z];
+    const ZoneFlagMap& zfm = zone.getZoneFlagMap();
+    ZoneFlagMap::const_iterator zfmIt;
+    for (zfmIt = zfm.begin(); zfmIt != zfm.end(); zfmIt++) {
+      if (zfmIt->first == flagType) {
+	count += zfmIt->second;
+      }
+    }
+  }
+  return count;
+}
+
+
+int FlagManager::addZoneTeamFlags(int startIndex, const FlagType* flagType,
+                                  const EntryZones& entryZones)
+{
+  if (!isAllowedType(flagType)) {
+    return startIndex;
+  }
+  // add zone team flags
+  const ZoneList& zl = entryZones.getZoneList();
+  for (int z = 0; z < (int)zl.size(); z++) {
+    const CustomZone& zone = zl[z];
+    const ZoneFlagMap& zfm = zone.getZoneFlagMap();
+    ZoneFlagMap::const_iterator zfmIt;
+    for (zfmIt = zfm.begin(); zfmIt != zfm.end(); zfmIt++) {
+      if (zfmIt->first == flagType) {
+	const int count = zfmIt->second;
+	for (int c = 0; c < count; c++) {
+	  FlagInfo& fi = flagList[startIndex];
+	  fi.setForcedFlag(flagType);
+	  fi.srcZone = &zone;
+	  startIndex++;
+	}
+      }
+    }
+  }
+  return startIndex;
+}
+
+
+void FlagManager::finalize()
+{
+  CmdLineOptions& options = *clOptions;
+  const EntryZones& entryZones = world-> getEntryZones();
+
+  // setup the forbidden flags
+  selectForbidden();  
+  removeForbidden(forcedFlags);
+  removeForbidden(randomFlags);
+
+  // make sure we have non-negative values
+  flagCountMapClampMin(forcedFlags, 0);
+  flagCountMapClampMin(randomFlags, 0);
+  if (extraCount < 0) {
+    extraCount = 0;
+  }
+  if (randomCount < 0) {
+    randomCount = 0;
+  }
+
+  // zone team flag counts
+  const int zoneTeamFlagCounts[5] = {
+    0, // rogue
+    getZoneTeamFlagCount(Flags::RedTeam, entryZones),
+    getZoneTeamFlagCount(Flags::GreenTeam, entryZones),
+    getZoneTeamFlagCount(Flags::BlueTeam, entryZones),
+    getZoneTeamFlagCount(Flags::PurpleTeam, entryZones)
+  };
+
+  // add a team flag for each active team
+  //   (if zone team flags are not being used)
+  if (options.gameStyle & TeamFlagGameStyle) {
+    for (int col = RedTeam; col <= PurpleTeam; col++) {
+      if ((options.maxTeam[col] > 0) && (zoneTeamFlagCounts[col] <= 0)) {
+        addToFlagCountMap(getTeamFlagType(col), 1, forcedFlags);
+      }
+    }
+  }
+
+  // make sure there are enough random flags in the pool
+  int randomPoolCount = flagCountMapSum(randomFlags);
+  if (randomPoolCount < randomCount) {
+    logDebugMessage(1, "WARNING: insufficient random flags in the pool (%i vs. %i)\n",
+           randomPoolCount, randomCount);
+// FIXME - Useless, better then a warning?
+//    const int missing = randomCount - randomPoolCount;
+//    addToFlagCountMap(Flags::Useless, missing, randomFlags);
+//    DEBUG1("WARNING: added %i useless random flags to satisfy the random count.\n",
+//           missing);
+  }
+
+  // zone flag count (including teams flags)
+  zoneCount = 0;
+  const ZoneList& zl = entryZones.getZoneList();
+  for (int z = 0; z < (int)zl.size(); z++) {
+    const CustomZone& zone = zl[z];
+    const ZoneFlagMap& zfm = zone.getZoneFlagMap();
+    ZoneFlagMap::const_iterator zfmIt;
+    for (zfmIt = zfm.begin(); zfmIt != zfm.end(); zfmIt++) {
+      if (isAllowedType(zfmIt->first)) {
+	zoneCount += zfmIt->second;
+      }
+    }
+  }
+
+  // forced count (including team flags)  
+  forcedCount = flagCountMapSum(forcedFlags);
+
+  //
+  // make the array  
+  ///////////////////
+
+  fullCount = zoneCount + forcedCount + randomCount + extraCount;
+  flagList = new FlagInfo[fullCount];
+
+  // set the slot numbers
+  for (int i = 0; i < fullCount; i++) {
+    flagList[i].flagIndex = i;
+  }
+
+  // add team flags (ordered, zone and forced)
+  int f = 0;
+  if (options.gameStyle & TeamFlagGameStyle) {
+    for (int t = RedTeam; t <= PurpleTeam; t++) {
+      if (options.maxTeam[t] > 0) {
+        const FlagType* ft = getTeamFlagType(t);
+        f = addZoneTeamFlags(f, ft, entryZones);
+        const int count = flagCountMapValue(ft, forcedFlags);
+        for (int n = 0; n < count; n++) {
+          flagList[f].setForcedFlag(ft);
+          f++;
+        }
+      }
+    }
+  }
+
+  // super flags?
+  if (f < fullCount) {
+    // FIXME -- not quite true,
+    //          multiple team flags can be converted into superflags
+    options.gameStyle |= int(SuperFlagGameStyle);
+  }
+
+  // add normal zone flags
+  for (int z = 0; z < (int)zl.size(); z++) {
+    const CustomZone& zone = zl[z];
+    const ZoneFlagMap& zfm = zone.getZoneFlagMap();
+    ZoneFlagMap::const_iterator zfmIt;
+    for (zfmIt = zfm.begin(); zfmIt != zfm.end(); zfmIt++) {
+      const FlagType* ft = zfmIt->first;
+      if ((ft->flagTeam == ::NoTeam) && // no team flags here
+	  (forbiddenFlags.find(ft) == forbiddenFlags.end())) {
+	const int count = zfmIt->second;
+	for (int c = 0; c < count; c++) {
+	  FlagInfo& fi = flagList[f];
+	  fi.setForcedFlag(ft);
+	  fi.srcZone = &zone;
+          f++;
+	}
+	if ((ft == Flags::Identify) && (count > 0)) {
+          zoneIdentifyFlag = true;
+        }
+      }
+    }
+  }
+
+  // add normal flags
+  FlagCountMap::const_iterator fcm_it;
+  for (fcm_it = forcedFlags.begin(); fcm_it != forcedFlags.end(); fcm_it++) {
+    const FlagType *ft = fcm_it->first;
+    if (ft->flagTeam == ::NoTeam) {
+      const int count = fcm_it->second;
+      for (int n = 0; n < count; n++) {
+        flagList[f].setForcedFlag(ft);
+        f++;
+      }
+    }
+  }
+
+  // add random flags
+  for (int rf = 0; rf < randomCount; rf++) {
+    flagList[f].setRandomFlag();
+    f++;
+  }
+
+  return;
+}
+
+
+void FlagManager::selectForbidden()
+{
+  CmdLineOptions& options = *clOptions;
+
+  // the obvious one
+  forbidType(Flags::Null);
+
+  // do we have any team flags?
+  bool hasTeam = false;
+  for (int p = RedTeam; p <= PurpleTeam; p++) {
+    if (options.maxTeam[p] > 1) {
+      hasTeam = true;
+      break;
+    }
+  }
+
+  // first disallow flags inconsistent with game style
+  if (options.gameStyle & JumpingGameStyle) {
+    forbidType(Flags::Jumping);
+  } else {
+    forbidType(Flags::NoJumping);
+  }
+  if (options.gameStyle & RicochetGameStyle) {
+    forbidType(Flags::Ricochet);
+  }
+  if (!options.useTeleporters && (options.worldFile == "")) {
+    forbidType(Flags::PhantomZone);
+  }
+  if (!hasTeam) {
+    forbidType(Flags::Genocide);
+    forbidType(Flags::Colorblindness);
+    forbidType(Flags::Masquerade);
+  }
+  if ((options.gameStyle & TeamFlagGameStyle) == 0) {
+    forbidType(Flags::RedTeam);
+    forbidType(Flags::GreenTeam);
+    forbidType(Flags::BlueTeam);
+    forbidType(Flags::PurpleTeam);
+  }
+  if (options.maxTeam[RedTeam] <= 0) {
+    forbidType(Flags::RedTeam);
+  }
+  if (options.maxTeam[GreenTeam] <= 0) {
+    forbidType(Flags::GreenTeam);
+  }
+  if (options.maxTeam[BlueTeam] <= 0) {
+    forbidType(Flags::BlueTeam);
+  }
+  if (options.maxTeam[PurpleTeam] <= 0) {
+    forbidType(Flags::PurpleTeam);
+  }
+
+  return;
+}
+
+
+void FlagManager::removeTeam(std::set<const FlagType*>& fs) const
+{
+  std::set<const FlagType*>::iterator it = fs.begin();
+  while (it != fs.end()) {
+    std::set<const FlagType*>::iterator tmp_it = it;
+    it++;
+    const FlagType* ft = *tmp_it;
+    if (ft->flagTeam != ::NoTeam) {
+      fs.erase(tmp_it);
+    }
+  }
+  return;
+}
+
+
+void FlagManager::removeForbidden(std::set<const FlagType*>& fs) const
+{
+  std::set<const FlagType*>::iterator it = fs.begin();
+  while (it != fs.end()) {
+    std::set<const FlagType*>::iterator tmp_it = it;
+    it++;
+    if (!isAllowedType(*tmp_it)) {
+      fs.erase(tmp_it);
+    }
+  }
+  return;
+}
+
+
+void FlagManager::removeForbidden(FlagCountMap& fcm) const
+{
+  FlagCountMap::iterator it = fcm.begin();
+  while (it != fcm.end()) {
+    FlagCountMap::iterator tmp_it = it;
+    it++;
+    if (!isAllowedType(tmp_it->first)) {
+      fcm.erase(tmp_it);
+    }
+  }
+  return;
+}
+
+
+const FlagType* FlagManager::getFlagTypeFromLabel(const char* label)
+{
+  if (strcasecmp(label, "all") == 0) {
+    return allFlagType;
+  }  
+  else if (strcasecmp(label, "bad") == 0) {
+    return badFlagType;
+  }  
+  else if (strcasecmp(label, "good") == 0) {
+    return goodFlagType;
+  }  
+  else if (strcasecmp(label, "team") == 0) {
+    return teamFlagType;
+  }  
+  else {
+    return Flag::getDescFromAbbreviation(label);
+  }
+}
+
+
+void FlagManager::getFlagSet(const FlagType* ft,
+                             std::set<const FlagType*>& fs) const
+{
+  fs.clear();
+
+  if (ft == allFlagType) {
+    const FlagTypeMap& ftm = FlagType::getFlagMap();
+    FlagTypeMap::const_iterator it;
+    for (it = ftm.begin(); it != ftm.end(); it++) {
+      const FlagType* ft_tmp = it->second;
+      if (ft_tmp->flagTeam == ::NoTeam) {
+        if (isAllowedType(ft_tmp)) {
+          fs.insert(ft_tmp);
+        }
+      }
+    }
+  }
+  else if (ft == teamFlagType) {
+    const FlagTypeMap& ftm = FlagType::getFlagMap();
+    FlagTypeMap::const_iterator it;
+    for (it = ftm.begin(); it != ftm.end(); it++) {
+      const FlagType* ft_tmp = it->second;
+      if (ft_tmp->flagTeam != ::NoTeam) {
+        if (isAllowedType(ft_tmp)) {
+          fs.insert(ft_tmp);
+        }
+      }
+    }
+  }
+  else if (ft == badFlagType) {
+    const FlagSet& badFlags = Flag::getBadFlags();
+    FlagSet::const_iterator it;
+    for (it = badFlags.begin(); it != badFlags.end(); it++) {
+      const FlagType* ft_tmp = *it;
+      if (ft_tmp->flagTeam == ::NoTeam) {
+        if (isAllowedType(ft_tmp)) {
+          fs.insert(ft_tmp);
+        }
+      }
+    }
+  }
+  else if (ft == goodFlagType) {
+    const FlagSet& goodFlags = Flag::getGoodFlags();
+    FlagSet::const_iterator it;
+    for (it = goodFlags.begin(); it != goodFlags.end(); it++) {
+      const FlagType* ft_tmp = *it;
+      if (ft_tmp->flagTeam == ::NoTeam) {
+        if (isAllowedType(ft_tmp)) {
+          fs.insert(ft_tmp);
+        }
+      }
+    }
+  }
+  else {
+    fs.insert(ft);
+  }
+
+  return;
+}
+
+
+void FlagManager::setExtraFlags(int count)
+{
+  if (count < 0) {
+    count = 0;
+  }
+  extraCount = count;
+  return;
+}
+
+
+void FlagManager::setRandomDelayTimes(float min, float max)
+{
+  if (min < 0.0f) { min = 0.0f; }
+  if (max < min) { max = min; }
+  minRandomDelay = min;
+  maxRandomDelay = max;
+  return;
+}
+
+
+void FlagManager::setRandomMaximum(int count)
+{
+  if (count < 0) {
+    count = 0;
+  }
+  randomCount = count;
+  return;
+}
+
+
+bool FlagManager::adjustForced(const char* type, int count)
+{
+  const FlagType* ft = getFlagTypeFromLabel(type);
+  if (ft == Flags::Null) {
+    return false;
+  }
+  std::set<const FlagType*> fs;
+  std::set<const FlagType*>::const_iterator it;
+  getFlagSet(ft, fs);
+  for (it = fs.begin(); it != fs.end(); it++) {
+    addToFlagCountMap(*it, count, forcedFlags);
+  }
+  return true;
+}
+
+
+bool FlagManager::adjustRandom(const char* type, int count)
+{
+  const FlagType* ft = getFlagTypeFromLabel(type);
+  if (ft == Flags::Null) {
+    return false;
+  }
+  std::set<const FlagType*> fs;
+  std::set<const FlagType*>::const_iterator it;
+  getFlagSet(ft, fs);
+  for (it = fs.begin(); it != fs.end(); it++) {
+    addToFlagCountMap(*it, count, randomFlags);
+  }
+  return true;
+}
+
+
+void FlagManager::forbidType(const FlagType* ft)
+{
+  forbiddenFlags.insert(ft);
+  return;
+}
+
+
+bool FlagManager::forbidType(const char* type)
+{
+  const FlagType* ft = getFlagTypeFromLabel(type);
+  if (ft == Flags::Null) {
+    return false;
+  }
+  std::set<const FlagType*> fs;
+  std::set<const FlagType*>::const_iterator it;
+  getFlagSet(ft, fs);
+
+// FIXME - let 'em do it
+//  removeTeam(fs); 
+//  if (fs.size() <= 0) {
+//    return false;
+//  }
+
+  for (it = fs.begin(); it != fs.end(); it++) {
+    forbidType(ft);
+  }
+
+  return true;
+}
+
+
+bool FlagManager::isAllowedType(const FlagType* ft) const
+{
+  return (forbiddenFlags.find(ft) == forbiddenFlags.end());
+}
+
+
+const FlagType* FlagManager::pickRandomFlagType() const
+{
+  // tally the random flags on the field
+  FlagCountMap currentRandom;
+  for (int i = 0; i < fullCount; i++) {
+    FlagInfo& fi = flagList[i];
+    if (fi.isRandom() && fi.exists()) {
+      addToFlagCountMap(fi.flag.type, 1, currentRandom);
+    }
+  }
+
+  // make a vector of missing random flags
+  std::vector<const FlagType*> missingFlags;
+  FlagCountMap::const_iterator it;
+  for (it = randomFlags.begin(); it != randomFlags.end(); it++) {
+    const FlagType* ft = it->first;
+    const int currentCount = flagCountMapValue(ft, currentRandom);
+    const int missingCount = it->second - currentCount;
+    for (int n = 0; n < missingCount; n++) {
+      missingFlags.push_back(ft);
+    }
+  }
+
+  // something is wrong
+  if (missingFlags.size() <= 0) {
+    return Flags::Null;
+  }
+
+  return missingFlags[rand() % missingFlags.size()];
+}
+
+
+void FlagManager::setNoFlagInAir()
+{
+  numFlagsInAir = 0;
+  return;
+}
+
+
+float FlagManager::getNextDrop(TimeKeeper &tm) const
+{
   // find timeout when next flag would hit ground
   float waitTime = 3.0f;
   if (numFlagsInAir > 0) {
-    for (int i = 0; i < numFlags; i++) {
-      FlagInfo &flag = flagList[i];
-      if (flag.flag.status != FlagNoExist &&
-	  flag.flag.status != FlagOnTank &&
-	  flag.flag.status != FlagOnGround &&
-	  flag.dropDone - tm < waitTime)
+    for (int i = 0; i < fullCount; i++) {
+      FlagInfo& flag = flagList[i];
+      if ((flag.flag.status != FlagNoExist) &&
+	  (flag.flag.status != FlagOnTank) &&
+	  (flag.flag.status != FlagOnGround) &&
+	  ((flag.dropDone - tm) < waitTime)) {
 	waitTime = float(flag.dropDone - tm);
+      }
     }
   }
   return waitTime;
 }
 
-bool FlagInfo::landing(const TimeKeeper &tm)
+
+void FlagManager::addRandomFlags(const TimeKeeper& tm)
 {
-  if (numFlagsInAir <= 0)
+  if (randomCount <= 0) {
+    return;
+  }
+
+  if (maxRandomDelay <= 0.0f) {
+    // add all of the unassigned random flags
+    for (int i = 0; i < fullCount; i++) {
+      FlagInfo &fi = flagList[i];
+      if (fi.isRandom() && (fi.flag.type == Flags::Null)) {
+        // flag in now entering game
+        fi.addFlag();
+        sendFlagUpdate(fi);
+      }
+    }
+    nextRandomInsertion = tm;
+  }
+  else if (nextRandomInsertion <= tm) {
+    // drop a random flag if available
+    for (int i = 0; i < fullCount; i++) {
+      FlagInfo &fi = flagList[i];
+      if (fi.isRandom() && (fi.flag.type == Flags::Null)) {
+        // flag in now entering game
+        fi.addFlag();
+        sendFlagUpdate(fi);
+        break;
+      }
+    }
+    // set the next insertion time
+    float r = (float)bzfrand();
+    nextRandomInsertion = tm;
+    nextRandomInsertion += minRandomDelay;
+    nextRandomInsertion += (r * (maxRandomDelay - minRandomDelay));
+  }
+
+  return;
+}
+
+
+int FlagManager::lookupFirstTeamFlag(int teamindex) const
+{
+  for (int i = 0; i < fullCount; i++) {
+    if (flagList[i].flag.type->flagTeam == teamindex) {
+      return i;
+    }
+  }
+  return -1;
+}
+
+
+bool FlagManager::identifyFlag() const
+{
+  if (zoneIdentifyFlag) {
+    return true;
+  }
+  if (forcedFlags.find(Flags::Identify) != forcedFlags.end()) {
+    return true;
+  }
+  if (randomCount > 0) {
+    if (randomFlags.find(Flags::Identify) != randomFlags.end()) {
+      return true;
+    }
+  }
+  return false;
+}
+
+
+/******************************************************************************/
+//
+// FlagManager::userXXX() members
+//
+
+static int compareAdd(const void* a, const void* b)
+{
+  const FlagInfo& fia = **((const FlagInfo**)a);
+  const FlagInfo& fib = **((const FlagInfo**)b);
+  if (fia.isExtra() && !fib.isExtra()) { return -1; }
+  if (!fia.isExtra() && fib.isExtra()) { return +1; }
+  return 0;
+}
+
+
+static int compareRemoveForced(const void* a, const void* b)
+{
+  const FlagInfo& fia = **((const FlagInfo**)a);
+  const FlagInfo& fib = **((const FlagInfo**)b);
+  if (!fia.isExtra() && fib.isExtra()) { return -1; }
+  if (fia.isExtra() && !fib.isExtra()) { return +1; }
+  if (!fia.isRandom() && fib.isRandom()) { return -1; }
+  if (fia.isRandom() && !fib.isRandom()) { return +1; }
+  const bool zoneA = (fia.getSourceZone() != NULL);
+  const bool zoneB = (fib.getSourceZone() != NULL);
+  if (!zoneA && zoneB) { return -1; }
+  if (zoneA && !zoneB) { return +1; }
+  const bool playerA = (fia.getPlayer() >= 0);
+  const bool playerB = (fib.getPlayer() >= 0);
+  if (!playerA && playerB) { return -1; }
+  if (playerA && !playerB) { return +1; }
+  return 0;
+}
+
+
+bool FlagManager::userAdjustForced(const char* type, int count, int playerIndex)
+{
+  const FlagType* ft = getFlagTypeFromLabel(type);
+  if (ft == Flags::Null) {
+    char buffer[MessageLen];
+    snprintf(buffer, MessageLen, "Invalid flag type: %s", type);
+    sendMessage(ServerPlayer, playerIndex, buffer);
     return false;
+  }
+  if (count == 0) {
+    return true;
+  }
 
-  bool land = false;
-  if (flag.status == FlagInAir || flag.status == FlagComing) {
-    if (dropDone - tm <= 0.0f) {
-      flag.status = FlagOnGround;
-      numFlagsInAir--;
-      land	= true;
+  std::set<const FlagType*> fs;
+  std::set<const FlagType*>::const_iterator it;
+  getFlagSet(ft, fs);
+  removeForbidden(fs);
+  if (fs.size() <= 0) {
+    char buffer[MessageLen];
+    snprintf(buffer, MessageLen, "Forbidden flag type: %s", type);
+    sendMessage(ServerPlayer, playerIndex, buffer);
+    return false;
+  }
+
+  const int guessCount = count * (int)fs.size();
+  if (guessCount > extraCount) {
+    char buf[MessageLen];
+    snprintf(buf, MessageLen, "Not enough extra slots (%i vs. %i)",
+             extraCount, guessCount);
+    sendMessage(ServerPlayer, playerIndex, buf);
+    return false;
+  }
+
+  if ((*fs.begin())->flagTeam != ::NoTeam) {
+    adjustTeamFlags(fs, count);
+    return true;
+  }
+
+  // setup the sorted list  
+  FlagInfo** sortList = new FlagInfo*[fullCount];
+  for (int i = 0; i < fullCount; i++) {
+    sortList[i] = &flagList[i];
+  }
+
+  if (count > 0) {
+    // add the new flags, and reset them
+    qsort(sortList, fullCount, sizeof(FlagInfo*), compareAdd);
+    for (it = fs.begin(); it != fs.end(); it++) {
+      const FlagType* ft_tmp = *it;
+      for (int n = 0; n < count; n++) {
+        int i;
+        for (i = 0; i < fullCount; i++) {
+          FlagInfo& fi = *sortList[i];
+          if (fi.isExtra()) {
+            extraCount--;
+            forcedCount++;
+            sendDrop(fi);
+            fi.setForcedFlag(ft_tmp);
+            addToFlagCountMap(ft_tmp, 1, forcedFlags);
+            resetFlag(fi);
+            break;
+          }
+        }
+        if (i == fullCount) {
+          break;
+        }
+      }
     }
-  } else if (flag.status == FlagGoing) {
-    if (dropDone - tm <= 0.0f) {
-      flag.status = FlagNoExist;
-      numFlagsInAir--;
-      land	= true;
+  }
+  else {
+    // remove the old flags, send out messages
+    qsort(sortList, fullCount, sizeof(FlagInfo*), compareRemoveForced);
+    for (it = fs.begin(); it != fs.end(); it++) {
+      const FlagType* ft_tmp = *it;
+      for (int n = 0; n < -count; n++) {
+        int i;
+        for (i = 0; i < fullCount; i++) {
+          FlagInfo& fi = *sortList[i];
+          if ((fi.getSourceZone() == NULL) &&
+              !fi.isExtra() && !fi.isRandom() &&
+              (fi.flag.type == ft_tmp)) {
+            extraCount++;
+            forcedCount--;
+            sendDrop(fi);
+            fi.setExtraFlag();
+            addToFlagCountMap(ft_tmp, -1, forcedFlags);
+            resetFlag(fi);
+            break;
+          }
+        }
+        if (i == fullCount) {
+          break;
+        }
+      }
     }
   }
-  return land;
+
+  delete[] sortList;
+
+  if (fs.size() == 1) {  
+    sendMessage(ServerPlayer, playerIndex, "adjusted flag count");
+  } else {
+    sendMessage(ServerPlayer, playerIndex, "adjusted flag counts");
+  }
+
+  return true;
 }
 
-void FlagInfo::setNoFlagInAir()
+/*
+static int compareZoneFlags(const void* a, const void* b)
 {
-  numFlagsInAir = 0;
+  const FlagInfo& fia = *((const FlagInfo*)a);
+  const FlagInfo& fib = *((const FlagInfo*)b);
+  const bool zoneA = (fia.getSourceZone() != NULL);
+  const bool zoneB = (fib.getSourceZone() != NULL);
+  if (!zoneA && zoneB) { return -1; }
+  if (zoneA && !zoneB) { return +1; }
+  return 0;
 }
+*/
 
-void FlagInfo::getTextualInfo(char *message)
+
+void FlagManager::adjustTeamFlags(std::set<const FlagType*>& fs, int count)
 {
-  sprintf(message, "#%-3d i:%-3s p:%-3d r:%-2d g:%-2d s:%-2d "
-		   "p:{%.1f, %.1f, %.1f}",
-	  flagIndex, flag.type->flagAbbv, player,
-	  required ? 1 : 0, grabs, flag.status,
-	  flag.position[0], flag.position[1], flag.position[2]);
+  int i;
+  int zoneTeamFlagCounts[5] = {0, 0, 0, 0, 0};
+
+  // setup the new forcedFlag counts
+  std::set<const FlagType*>::const_iterator fs_it;
+  for (fs_it = fs.begin(); fs_it != fs.end(); fs_it++) {
+    const FlagType* ft = *fs_it;
+    addToFlagCountMap(ft, count, forcedFlags);
+  }
+  flagCountMapClampMin(forcedFlags, 0);
+
+  // adjust extraCount and forcedCount
+  const int newForcedCount = flagCountMapSum(forcedFlags);
+  extraCount -= (newForcedCount - forcedCount);
+  forcedCount = newForcedCount;
+
+  // remove all player flags
+  for (i = 0; i < fullCount; i++) {
+    sendDrop(flagList[i]);
+  }
+
+  //
+  // shiny new list
+  ///////////////////
+  FlagInfo* newList = new FlagInfo[fullCount];
+
+  // add the team flags
+  int f = 0;
+  for (int t = RedTeam; t <= PurpleTeam; t++) {
+    const FlagType* ft = getTeamFlagType(t);
+    // copy the team zone flags
+    for (i = 0; i < fullCount; i++) {
+      FlagInfo& fi = flagList[i];
+      if ((fi.srcZone != NULL) && (fi.flag.type == ft)) {
+        zoneTeamFlagCounts[t]++;
+        newList[f] = flagList[i];
+        f++;
+      }
+    }
+    // fill the team flags
+    const int teamCount = flagCountMapValue(ft, forcedFlags);
+    for (i = 0; i < teamCount; i++) {
+      newList[f].setForcedFlag(ft);
+      f++;
+    }
+  }
+
+  // copy the normal zone flags
+  for (i = 0; i < fullCount; i++) {
+    FlagInfo& fi = flagList[i];
+    if ((fi.srcZone != NULL) && (fi.getTeamIndex() == ::NoTeam)) {
+      newList[f] = flagList[i];
+      f++;
+    }
+  }
+
+  // add normal flags
+  FlagCountMap::const_iterator fcm_it;
+  for (fcm_it = forcedFlags.begin(); fcm_it != forcedFlags.end(); fcm_it++) {
+    const FlagType *ft = fcm_it->first;
+    if (ft->flagTeam == ::NoTeam) {
+      const int flagCount = fcm_it->second;
+      for (int n = 0; n < flagCount; n++) {
+        newList[f].setForcedFlag(ft);
+        f++;
+      }
+    }
+  }
+
+  // add random flags
+  for (int rf = 0; rf < randomCount; rf++) {
+    newList[f].setRandomFlag();
+    f++;
+  }
+
+  // set the slot numbers
+  for (i = 0; i < fullCount; i++) {
+    newList[i].flagIndex = i;
+  }
+
+  // out with the old, in with the new
+  delete[] flagList;
+  flagList = newList;
+
+  // reset 'em
+  for (i = 0; i < fullCount; i++) {
+    resetFlag(flagList[i]);
+  }
+
+  return;
 }
 
-bool FlagInfo::exist()
+
+static int compareRemoveRandom(const void* a, const void* b)
 {
-  return flag.status != FlagNoExist;
+  const FlagInfo& fia = **((const FlagInfo**)a);
+  const FlagInfo& fib = **((const FlagInfo**)b);
+  if (!fia.exists() && fib.exists()) { return -1; }
+  if (fia.exists() && !fib.exists()) { return +1; }
+  if (!fia.isExtra() && fib.isExtra()) { return -1; }
+  if (fia.isExtra() && !fib.isExtra()) { return +1; }
+  if (fia.isRandom() && !fib.isRandom()) { return -1; }
+  if (!fia.isRandom() && fib.isRandom()) { return +1; }
+  const bool zoneA = (fia.getSourceZone() != NULL);
+  const bool zoneB = (fib.getSourceZone() != NULL);
+  if (!zoneA && zoneB) { return -1; }
+  if (zoneA && !zoneB) { return +1; }
+  const bool playerA = (fia.getPlayer() >= 0);
+  const bool playerB = (fib.getPlayer() >= 0);
+  if (!playerA && playerB) { return -1; }
+  if (playerA && !playerB) { return +1; }
+  return 0;
 }
 
-FlagInfo *FlagInfo::get(int index)
+
+bool FlagManager::userAdjustRandom(const char* type, int count, int playerIndex)
 {
-  if (index < 0)
-    return NULL;
-  if (index >= numFlags)
-    return NULL;
-  return &flagList[index];
+  const FlagType* ft = getFlagTypeFromLabel(type);
+  if (ft == Flags::Null) {
+    char buffer[MessageLen];
+    snprintf(buffer, MessageLen, "Invalid flag type: %s", type);
+    sendMessage(ServerPlayer, playerIndex, buffer);
+    return false;
+  }
+
+  if (count == 0) {
+    return true;
+  }
+
+  std::set<const FlagType*> fs;
+  std::set<const FlagType*>::const_iterator it;
+  getFlagSet(ft, fs);
+  removeTeam(fs); // no random team flags
+  removeForbidden(fs);
+  if (fs.size() <= 0) {
+    char buffer[MessageLen];
+    snprintf(buffer, MessageLen, "Forbidden flag type: %s", type);
+    sendMessage(ServerPlayer, playerIndex, buffer);
+    return false;
+  }
+
+  for (it = fs.begin(); it != fs.end(); it++) {
+    addToFlagCountMap(*it, count, randomFlags);
+  }
+
+  flagCountMapClampMin(randomFlags, 0);
+
+  // tally the random flags on the field
+  FlagCountMap currentRandom;
+  for (int i = 0; i < fullCount; i++) {
+    FlagInfo& fi = flagList[i];
+    if (fi.isRandom() && fi.exists()) {
+      addToFlagCountMap(fi.flag.type, 1, currentRandom);
+    }
+  }
+
+  // make a map of excess random flags
+  FlagCountMap excessFlags;
+  FlagCountMap::const_iterator fcm_it;
+  for (fcm_it = currentRandom.begin(); fcm_it != currentRandom.end(); fcm_it++) {
+    const FlagType* ft_tmp = fcm_it->first;
+    const int currentCount = flagCountMapValue(ft_tmp, currentRandom);
+    const int maximumCount = flagCountMapValue(ft_tmp, randomFlags);
+    const int excess = currentCount - maximumCount;
+    if (excess > 0) {
+      excessFlags[ft_tmp] = excess;
+    }
+  }
+
+  if (excessFlags.size() <= 0) {
+    return true; // no excess flags
+  }
+
+  // setup the sorted list  
+  FlagInfo** sortList = new FlagInfo*[fullCount];
+  for (int j = 0; j < fullCount; j++) {
+    sortList[j] = &flagList[j];
+  }
+
+  // reset any excess flags, randomFlags has already been adjusted
+  qsort(sortList, fullCount, sizeof(FlagInfo*), compareRemoveRandom);
+  for (fcm_it = excessFlags.begin(); fcm_it != excessFlags.end(); fcm_it++) {
+    const FlagType* ft_tmp = fcm_it->first;
+    int excess = fcm_it->second;
+    for (int i = 0; i < fullCount; i++) {
+      FlagInfo& fi = *sortList[i];
+      if ((fi.getSourceZone() == NULL) &&
+          !fi.isExtra() && fi.isRandom() &&
+          (fi.flag.type == ft_tmp)) {
+        sendDrop(fi);
+        resetFlag(fi);
+        excess--;
+        if (excess <= 0) {
+          break;
+        }
+      }
+    }
+  }
+
+  delete[] sortList;
+
+  sendMessage(ServerPlayer, playerIndex, "adjusted flag pool count");
+
+  return true;
 }
 
+
+bool FlagManager::userSetRandomCount(int count, int playerIndex)
+{
+  if (count < 0) {
+    count = 0;
+  }
+  const int diff = (count - randomCount);
+  if (diff == 0) {
+    return true;
+  }
+
+  if (diff > extraCount) {
+    char buf[MessageLen];
+    snprintf(buf, MessageLen, "Not enough extra slots (%i vs. %i)",
+             extraCount, count);
+    sendMessage(ServerPlayer, playerIndex, buf);
+    return false;
+  }
+
+  // setup the sorted list  
+  FlagInfo** sortList = new FlagInfo*[fullCount];
+  for (int i = 0; i < fullCount; i++) {
+    sortList[i] = &flagList[i];
+  }
+
+  if (diff > 0) {
+    // convert extra slots into random slots
+    qsort(sortList, fullCount, sizeof(FlagInfo*), compareAdd);
+    int changed = 0;
+    for (int i = 0; i < fullCount; i++) {
+      FlagInfo& fi = *sortList[i];
+      if (fi.isExtra()) {
+        extraCount--;
+        randomCount++;
+        sendDrop(fi);
+        fi.setRandomFlag();
+        resetFlag(fi);
+        changed++;
+        if (changed >= diff) {
+          break;
+        }
+      }
+    }
+  }
+  else {
+    // convert random slots into extra slots
+    qsort(sortList, fullCount, sizeof(FlagInfo*), compareRemoveRandom);
+    int changed = 0;
+    for (int i = 0; i < fullCount; i++) {
+      FlagInfo& fi = *sortList[i];
+      if (fi.isRandom()) {
+        extraCount++;
+        randomCount--;
+        changed++;
+        sendDrop(fi);
+        fi.setExtraFlag();
+        resetFlag(fi);
+        if (changed >= -diff) {
+          break;
+        }
+      }
+    }
+  }
+
+  delete[] sortList;
+
+  sendMessage(ServerPlayer, playerIndex, "set random flag maximum");
+
+  return true;
+}
+
+
+/******************************************************************************/
+//
+// FlagManager::sendFlagInfo() and friends
+//
+
+typedef std::pair<const FlagType*, int> FlagCountPair;
+
+
+
+void FlagManager::sendFlagInfo(int playerIndex) const
+{
+  std::vector<std::string> text;
+  getFlagList(text);
+  for (int i = 0; i < (int)text.size(); i++) {
+    sendMessage(ServerPlayer, playerIndex, text[i].c_str());
+  }
+  return;
+}
+
+
+static bool compareFlagType(const FlagCountPair& a, const FlagCountPair& b)
+{
+  const FlagType* fta = a.first;
+  const FlagType* ftb = b.first;
+  const bool isGoodA = (fta->flagQuality == FlagGood);
+  const bool isGoodB = (ftb->flagQuality == FlagGood);
+  if (isGoodA && !isGoodB) {
+    return true;
+  }
+  if (!isGoodA && isGoodB) {
+    return false;
+  }
+  return (strcmp(fta->flagAbbv, ftb->flagAbbv) < 0);
+}
+
+
+static void appendFlagCounts(const FlagCountMap& fcm,
+                             std::vector<std::string>& text)
+{
+  const int maxColumn = 8;
+  char buf[MessageLen];
+  char* c = buf;
+
+  FlagCountMap::const_iterator fcm_it;
+  std::vector<FlagCountPair> sortList;
+  for (fcm_it = fcm.begin(); fcm_it != fcm.end(); fcm_it++) {
+    sortList.push_back(FlagCountPair(fcm_it->first, fcm_it->second));
+  }
+  std::sort(sortList.begin(), sortList.end(), compareFlagType);
+
+  int column = 0;
+  std::vector<FlagCountPair>::const_iterator sort_it = sortList.begin();
+  while (sort_it != sortList.end()) {
+    const FlagType* ft = sort_it->first;
+    const int count = sort_it->second;
+    sort_it++; // increment here to check for sortList.end() before looping
+    if (count > 0) {
+      column++;
+      const int maxSize = (MessageLen - (c - buf));
+      c += snprintf(c, maxSize, "  %2s/%-3i", ft->flagAbbv, count);
+    }
+    if ((sort_it == sortList.end()) || (column >= maxColumn)) {
+      text.push_back(buf);
+      c = buf;
+      column = 0;
+    }
+  }
+  return;
+}    
+
+
+static void appendTeamFlagCounts(const FlagCountMap& fcm,
+                                 std::vector<std::string>& text)
+{
+  char buf[MessageLen];
+  char* c = buf;
+  for (int t = RedTeam; t <= PurpleTeam; t++) {
+    const FlagType* ft = FLAGMGR.getTeamFlagType(t);
+    FlagCountMap::const_iterator fcm_it = fcm.find(ft);
+    int count = 0;
+    if (fcm_it != fcm.end()) {
+      count = fcm_it->second;
+    }
+    const int maxSize = (MessageLen - (c - buf));
+    c += snprintf(c, maxSize, "  %2s/%-3i", ft->flagAbbv, count);
+  }
+  text.push_back(buf);
+  return;
+}
+
+
+void FlagManager::getFlagList(std::vector<std::string>& text) const
+{
+  text.clear();
+
+  // tally the flags
+  int teamTally = 0;
+  int zoneTeamTally = 0;
+  int zoneTally = 0;
+  int forcedTally = 0;
+  int randomTally = 0;
+  FlagCountMap teamTallyList;
+  FlagCountMap zoneTeamTallyList;
+  FlagCountMap zoneTallyList;
+  FlagCountMap forcedTallyList;
+  FlagCountMap randomTallyList;
+
+  for (int i = 0; i < fullCount; i++) {
+    const FlagInfo& fi = flagList[i];
+    const FlagType* ft = fi.flag.type;
+    if (fi.isExtra()) {
+      continue;
+    }
+    else if (fi.srcZone != NULL) {
+      if (ft->flagTeam != ::NoTeam) {
+        zoneTeamTally++;
+        addToFlagCountMap(ft, 1, zoneTeamTallyList);
+      } else {
+        zoneTally++;
+        addToFlagCountMap(ft, 1, zoneTallyList);
+      }
+    }
+    else {
+      if (ft->flagTeam != ::NoTeam) {
+        teamTally++;
+        addToFlagCountMap(ft, 1, teamTallyList);
+      }
+      else {
+        if (fi.isRandom()) {
+          if (fi.flag.type != Flags::Null) {
+            randomTally++;
+            addToFlagCountMap(ft, 1, randomTallyList);
+          }
+        } else {
+          forcedTally++;
+          addToFlagCountMap(ft, 1, forcedTallyList);
+        }
+      }
+    }
+  }
+
+  // append the info
+  char buf[MessageLen];
+
+  snprintf(buf, MessageLen, "Team(%i)", teamTally);
+  text.push_back(buf);
+  appendTeamFlagCounts(teamTallyList, text);
+
+  snprintf(buf, MessageLen, "TeamZone(%i)", zoneTeamTally);
+  text.push_back(buf);
+  appendTeamFlagCounts(zoneTeamTallyList, text);
+
+  snprintf(buf, MessageLen, "Zone(%i)", zoneTally);
+  text.push_back(buf);
+  appendFlagCounts(zoneTallyList, text);
+
+  snprintf(buf, MessageLen, "Forced(%i)", forcedTally);
+  text.push_back(buf);
+  appendFlagCounts(forcedTallyList, text);
+
+  snprintf(buf, MessageLen, "Random(%i)", randomTally);
+  text.push_back(buf);
+  appendFlagCounts(randomTallyList, text);
+
+  snprintf(buf, MessageLen, "RandomPool(%i)", randomCount);
+  text.push_back(buf);
+  appendFlagCounts(randomFlags, text);
+
+  snprintf(buf, MessageLen, "Extra Flags(%i)", extraCount);
+  text.push_back(buf);
+
+  return;
+}
+
+
+/******************************************************************************/
+//
+// Utilities
+//
+
+static int flagCountMapSum(FlagCountMap& fcm)
+{
+  int tally = 0;
+  FlagCountMap::iterator it;
+  for (it = fcm.begin(); it != fcm.end(); it++) {
+    tally += it->second;
+  }
+  return tally;
+}
+
+
+static void flagCountMapClampMin(FlagCountMap& fcm, int min)
+{
+  FlagCountMap::iterator it = fcm.begin();
+  while (it != fcm.end()) {
+    FlagCountMap::iterator tmp_it = it;
+    it++;
+    if (tmp_it->second <= min) {
+      tmp_it->second = min;
+      if (min == 0) {
+        fcm.erase(tmp_it);
+      }
+    }
+  }
+  return;
+}
+
+
+static int flagCountMapValue(const FlagType* ft, const FlagCountMap& fcm)
+{
+  FlagCountMap::const_iterator it = fcm.find(ft);
+  if (it != fcm.end()) {
+    return it->second;
+  }
+  return 0;
+}
+
+
+static void addToFlagCountMap(const FlagType* ft, int count,
+                              FlagCountMap& fcm)
+{
+  FlagCountMap::iterator it = fcm.find(ft);
+  if (it != fcm.end()) {
+    it->second += count;
+    if (it->second == 0) {
+      fcm.erase(it);
+    }
+  } else {
+    fcm[ft] = count;
+  }
+  return;
+}                              
+
+
 // Local Variables: ***
 // mode:C++ ***
 // tab-width: 8 ***
